package stx.libjava.tools.source;

import org.eclipse.jdt.internal.compiler.CompilationResult;
import org.eclipse.jdt.internal.compiler.DefaultErrorHandlingPolicies;
import org.eclipse.jdt.internal.compiler.ast.CompilationUnitDeclaration;
import org.eclipse.jdt.internal.compiler.env.ICompilationUnit;
import org.eclipse.jdt.internal.compiler.impl.CompilerOptions;
import org.eclipse.jdt.internal.compiler.parser.Parser;
import org.eclipse.jdt.internal.compiler.problem.DefaultProblemFactory;
import org.eclipse.jdt.internal.compiler.problem.ProblemReporter;


public class JavaSourceParser extends Parser {
    
    public JavaSourceParser() {
        this(
                new ProblemReporter(
                        DefaultErrorHandlingPolicies.proceedWithAllProblems(), 
                        new CompilerOptions(), 
                        new DefaultProblemFactory()),
                true);                
    }
    

    public JavaSourceParser(ProblemReporter problemReporter,
            boolean optimizeStringLiterals) {
        super(problemReporter, optimizeStringLiterals);
        options.docCommentSupport = true;
        javadocParser.checkDocComment = true;
    }

    public CompilationUnitDeclaration parse(ICompilationUnit cu, boolean diet) {
        if (diet) {
            return dietParse(cu, new CompilationResult(cu, 1, 1, 1000));
        } else {
            return parse(cu, new CompilationResult(cu, 1, 1, 1000 ));            
        }
    }

}
